class HelpTest
Same name in this branch
- main core/modules/help/tests/src/Functional/HelpTest.php \Drupal\Tests\help\Functional\HelpTest
Same name and namespace in other branches
- 11.x core/modules/help/tests/src/Functional/HelpTest.php \Drupal\Tests\help\Functional\HelpTest
- 10 core/modules/help/tests/src/Functional/HelpTest.php \Drupal\Tests\help\Functional\HelpTest
- 9 core/modules/help/tests/src/Functional/HelpTest.php \Drupal\Tests\help\Functional\HelpTest
- 8.9.x core/modules/help/tests/src/Functional/HelpTest.php \Drupal\Tests\help\Functional\HelpTest
- 11.x core/modules/help/tests/src/Kernel/HelpTest.php \Drupal\Tests\help\Kernel\HelpTest
Verify help display and user access to help based on permissions.
Attributes
#[Group('help')]
#[RunTestsInSeparateProcesses]
Hierarchy
- class \Drupal\KernelTests\KernelTestBase implements \Drupal\Core\DependencyInjection\ServiceProviderInterface uses \Drupal\Tests\DrupalTestCaseTrait, \Drupal\KernelTests\AssertContentTrait, \Drupal\Tests\RandomGeneratorTrait, \Drupal\Tests\ConfigTestTrait, \Drupal\Tests\ExtensionListTestTrait, \Prophecy\PhpUnit\ProphecyTrait, \Drupal\Tests\BrowserHtmlDebugTrait, \Drupal\Tests\HttpKernelUiHelperTrait extends \PHPUnit\Framework\TestCase
- class \Drupal\Tests\help\Kernel\HelpTest uses \Drupal\Tests\block\Traits\BlockCreationTrait, \Drupal\Tests\HttpKernelUiHelperTrait, \Drupal\Tests\user\Traits\UserCreationTrait extends \Drupal\KernelTests\KernelTestBase
Expanded class hierarchy of HelpTest
File
-
core/
modules/ help/ tests/ src/ Kernel/ HelpTest.php, line 18
Namespace
Drupal\Tests\help\KernelView source
class HelpTest extends KernelTestBase {
use BlockCreationTrait;
use HttpKernelUiHelperTrait;
use UserCreationTrait;
/**
* Modules to install.
*
* The help_test module implements hook_help() but does not provide a module
* overview page. The help_page_test module has a page section plugin that
* returns no links.
*
* @var array
*/
protected static $modules = [
'block',
'block_content',
'breakpoint',
'editor',
'filter',
'help',
'help_page_test',
'help_test',
'system',
'user',
];
/**
* The admin user that will be created.
*
* @var \Drupal\user\Entity\User|false
*/
protected $adminUser;
/**
* The anonymous user that will be created.
*
* @var \Drupal\user\Entity\User|false
*/
protected $anyUser;
/**
* {@inheritdoc}
*/
protected function setUp() : void {
parent::setUp();
$this->installEntitySchema('block');
$this->installEntitySchema('block_content');
$this->installEntitySchema('user');
// Create users.
$this->adminUser = $this->createUser([
'access help pages',
'view the administration theme',
'administer permissions',
]);
$this->anyUser = $this->createUser();
$this->installConfig('system');
$this->config('system.site')
->set('name', 'Drupal')
->save();
$this->container
->get('theme_installer')
->install([
'stark',
]);
$this->config('system.theme')
->set('default', 'stark')
->save();
$this->placeBlock('page_title_block');
$this->placeBlock('help_block');
}
/**
* Logs in users, tests help pages.
*/
public function testHelp() : void {
// Log in the root user to ensure as many admin links appear as possible on
// the module overview pages.
$this->setCurrentUser($this->createUser([
'access help pages',
'access administration pages',
]));
$this->verifyHelp();
// Log in the regular user.
$this->setCurrentUser($this->anyUser);
$this->verifyHelp(403);
// Verify that introductory help text exists, goes for 100% module coverage.
$this->setCurrentUser($this->adminUser);
$this->drupalGet('admin/help');
$this->assertSession()
->responseContains('For more information, refer to the help listed on this page or to the <a href="https://www.drupal.org/documentation">online documentation</a> and <a href="https://www.drupal.org/support">support</a> pages at <a href="https://www.drupal.org">drupal.org</a>.');
// Verify that hook_help() section title and description appear.
$this->assertSession()
->responseContains('<h2 id="hook-help">Module overviews</h2>');
$this->assertSession()
->responseContains('<p>Module overviews are provided by modules. Overviews available for your installed modules:</p>');
// Verify that an empty section is handled correctly.
$this->assertSession()
->responseContains('<h2 id="empty-section">Empty section</h2>');
$this->assertSession()
->responseContains('<p>This description should appear.</p>');
$this->assertSession()
->pageTextContains('There is currently nothing in this section.');
// Make sure links are properly added for modules implementing hook_help().
foreach ($this->getModuleList() as $module => $name) {
$this->assertSession()
->linkExists($name, 0, new FormattableMarkup('Link properly added to @name (admin/help/@module)', [
'@module' => $module,
'@name' => $name,
]));
}
// Ensure a module which does not provide a module overview page is handled
// correctly.
$module_name = \Drupal::service('extension.list.module')->getName('help_test');
$this->clickLink($module_name);
$this->assertSession()
->pageTextContains('No help is available for module ' . $module_name);
// Verify that the order of topics is alphabetical by displayed module
// name, by checking the order of some modules, including some that would
// have a different order if it was done by machine name instead.
$this->drupalGet('admin/help');
$page_text = $this->getTextContent();
$start = strpos($page_text, 'Module overviews');
$pos = $start;
$list = [
'Block',
'Block Content',
'Breakpoint',
'Text Editor',
];
foreach ($list as $name) {
$this->assertSession()
->linkExists($name);
$new_pos = strpos($page_text, $name, $start);
$this->assertGreaterThan($pos, $new_pos, "Order of {$name} is not correct on page");
$pos = $new_pos;
}
}
/**
* Verifies the logged in user has access to the various help pages.
*
* @param int $response
* (optional) An HTTP response code. Defaults to 200.
*/
protected function verifyHelp($response = 200) : void {
$this->drupalGet('admin/index');
$this->assertSession()
->statusCodeEquals($response);
if ($response == 200) {
$this->assertSession()
->pageTextContains('This page shows you all available administration tasks for each module.');
}
else {
$this->assertSession()
->pageTextNotContains('This page shows you all available administration tasks for each module.');
}
$module_list = \Drupal::service('extension.list.module');
foreach ($this->getModuleList() as $module => $name) {
// View module help page.
$this->drupalGet('admin/help/' . $module);
$this->assertSession()
->statusCodeEquals($response);
if ($response == 200) {
$this->assertSession()
->titleEquals("{$name} | Drupal");
$this->assertSession()
->elementTextEquals('css', 'h1', $name);
$info = $module_list->getExtensionInfo($module);
$admin_tasks = \Drupal::service('system.module_admin_links_helper')->getModuleAdminLinks($module);
if ($module_permissions_link = \Drupal::service('user.module_permissions_link_helper')->getModulePermissionsLink($module, $info['name'])) {
$admin_tasks["user.admin_permissions.{$module}"] = $module_permissions_link;
}
if (!empty($admin_tasks)) {
$this->assertSession()
->pageTextContains($name . ' administration pages');
}
foreach ($admin_tasks as $task) {
$this->assertSession()
->linkExists($task['title']);
// Ensure there are no double escaped '&' or '<' characters.
$this->assertSession()
->assertNoEscaped('&');
$this->assertSession()
->assertNoEscaped('<');
// Ensure there are no escaped '<' characters.
$this->assertSession()
->assertNoEscaped('<');
}
// Ensure there are no double escaped '&' or '<' characters.
$this->assertSession()
->assertNoEscaped('&');
$this->assertSession()
->assertNoEscaped('<');
// The help for CKEditor 5 intentionally has escaped '<' so leave this
// iteration before the assertion below.
if ($module === 'ckeditor5') {
continue;
}
// Ensure there are no escaped '<' characters.
$this->assertSession()
->assertNoEscaped('<');
}
}
}
/**
* Gets the list of enabled modules that implement hook_help().
*
* @return array
* A list of enabled modules.
*/
protected function getModuleList() : array {
$modules = [];
$module_data = $this->container
->get('extension.list.module')
->getList();
\Drupal::moduleHandler()->invokeAllWith('help', function (callable $hook, string $module) use (&$modules, $module_data) : void {
$modules[$module] = $module_data[$module]->info['name'];
});
return $modules;
}
}
Members
| Title Sort descending | Deprecated | Modifiers | Object type | Summary | Overriden Title | Overrides |
|---|---|---|---|---|---|---|
| AssertContentTrait::$content | protected | property | The current raw content. | |||
| AssertContentTrait::$drupalSettings | protected | property | The drupalSettings value from the current raw $content. | |||
| AssertContentTrait::$elements | protected | property | The XML structure parsed from the current raw $content. | |||
| AssertContentTrait::$plainTextContent | protected | property | The plain-text content of raw $content (text nodes). | |||
| AssertContentTrait::assertEscaped | protected | function | Passes if the raw text IS found escaped on the loaded page, fail otherwise. | |||
| AssertContentTrait::assertField | protected | function | Asserts that a field exists with the given name or ID. | |||
| AssertContentTrait::assertFieldByName | protected | function | Asserts that a field exists with the given name and value. | |||
| AssertContentTrait::assertFieldByXPath | protected | function | Asserts that a field exists in the current page by the given XPath. | |||
| AssertContentTrait::assertFieldsByValue | protected | function | Asserts that a field exists in the current page with a given Xpath result. | |||
| AssertContentTrait::assertLink | protected | function | Passes if a link with the specified label is found. | |||
| AssertContentTrait::assertLinkByHref | protected | function | Passes if a link containing a given href (part) is found. | |||
| AssertContentTrait::assertNoLink | protected | function | Passes if a link with the specified label is not found. | |||
| AssertContentTrait::assertNoPattern | protected | function | Triggers a pass if the perl regex pattern is not found in raw content. | |||
| AssertContentTrait::assertNoRaw | protected | function | Passes if the raw text is NOT found on the loaded page, fail otherwise. | |||
| AssertContentTrait::assertNoText | protected | function | Passes if the page (with HTML stripped) does not contains the text. | |||
| AssertContentTrait::assertPattern | protected | function | Triggers a pass if the Perl regex pattern is found in the raw content. | |||
| AssertContentTrait::assertRaw | protected | function | Passes if the raw text IS found on the loaded page, fail otherwise. | |||
| AssertContentTrait::assertText | protected | function | Passes if the page (with HTML stripped) contains the text. | |||
| AssertContentTrait::assertTextHelper | protected | function | Helper for assertText and assertNoText. | |||
| AssertContentTrait::assertThemeOutput | protected | function | Asserts themed output. | |||
| AssertContentTrait::assertTitle | protected | function | Pass if the page title is the given string. | |||
| AssertContentTrait::buildXPathQuery | protected | function | Builds an XPath query. | |||
| AssertContentTrait::constructFieldXpath | protected | function | Helper: Constructs an XPath for the given set of attributes and value. | |||
| AssertContentTrait::cssSelect | protected | function | Searches elements using a CSS selector in the raw content. | |||
| AssertContentTrait::getAllOptions | protected | function | Get all option elements, including nested options, in a select. | |||
| AssertContentTrait::getDrupalSettings | protected | function | Gets the value of drupalSettings for the currently-loaded page. | |||
| AssertContentTrait::getRawContent | protected | function | Gets the current raw content. | |||
| AssertContentTrait::getSelectedItem | protected | function | Get the selected value from a select field. | |||
| AssertContentTrait::getTextContent | protected | function | Retrieves the plain-text content from the current raw content. | |||
| AssertContentTrait::parse | protected | function | Parse content returned from curlExec using DOM and SimpleXML. | |||
| AssertContentTrait::removeWhiteSpace | protected | function | Removes all white-space between HTML tags from the raw content. | |||
| AssertContentTrait::setDrupalSettings | protected | function | Sets the value of drupalSettings for the currently-loaded page. | |||
| AssertContentTrait::setRawContent | protected | function | Sets the raw content (e.g. HTML). | |||
| AssertContentTrait::xpath | protected | function | Performs an xpath search on the contents of the internal browser. | |||
| BlockCreationTrait::placeBlock | protected | function | Creates a block instance based on default settings. | |||
| BrowserHtmlDebugTrait::$htmlOutputBaseUrl | protected | property | The Base URI to use for links to the output files. | |||
| BrowserHtmlDebugTrait::$htmlOutputClassName | protected | property | Class name for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputCounter | protected | property | Counter for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputCounterStorage | protected | property | Counter storage for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputDirectory | protected | property | Directory name for HTML output logging. | |||
| BrowserHtmlDebugTrait::$htmlOutputEnabled | protected | property | HTML output enabled. | |||
| BrowserHtmlDebugTrait::$htmlOutputTestId | protected | property | HTML output test ID. | |||
| BrowserHtmlDebugTrait::formatHtmlOutputHeaders | protected | function | Formats HTTP headers as string for HTML output logging. | |||
| BrowserHtmlDebugTrait::getHtmlOutputHeaders | protected | function | Returns headers in HTML output format. | 1 | ||
| BrowserHtmlDebugTrait::getResponseLogHandler | protected | function | Provides a Guzzle middleware handler to log every response received. | |||
| BrowserHtmlDebugTrait::getTestMethodCaller | protected | function | Retrieves the current calling line in the class under test. | 1 | ||
| BrowserHtmlDebugTrait::htmlOutput | protected | function | Logs a HTML output message in a text file. | |||
| BrowserHtmlDebugTrait::initBrowserOutputFile | protected | function | Creates the directory to store browser output. | |||
| ConfigTestTrait::configImporter | protected | function | Returns a ConfigImporter object to import test configuration. | |||
| ConfigTestTrait::copyConfig | protected | function | Copies configuration objects from source storage to target storage. | |||
| DrupalTestCaseTrait::$root | protected | property | The Drupal root directory. | |||
| DrupalTestCaseTrait::checkErrorHandlerOnTearDown | public | function | Checks the test error handler after test execution. | 1 | ||
| DrupalTestCaseTrait::getDrupalRoot | Deprecated | protected static | function | Returns the Drupal root directory. | 1 | |
| DrupalTestCaseTrait::setDebugDumpHandler | public static | function | Registers the dumper CLI handler when the DebugDump extension is enabled. | |||
| DrupalTestCaseTrait::setUpRoot | final protected | function | Ensure that the $root property is set initially. | |||
| ExtensionListTestTrait::getModulePath | protected | function | Gets the path for the specified module. | |||
| ExtensionListTestTrait::getThemePath | protected | function | Gets the path for the specified theme. | |||
| HelpTest::$adminUser | protected | property | The admin user that will be created. | |||
| HelpTest::$anyUser | protected | property | The anonymous user that will be created. | |||
| HelpTest::$modules | protected static | property | Modules to install. | Overrides KernelTestBase::$modules | ||
| HelpTest::getModuleList | protected | function | Gets the list of enabled modules that implement hook_help(). | |||
| HelpTest::setUp | protected | function | Overrides KernelTestBase::setUp | |||
| HelpTest::testHelp | public | function | Logs in users, tests help pages. | |||
| HelpTest::verifyHelp | protected | function | Verifies the logged in user has access to the various help pages. | |||
| HttpKernelUiHelperTrait::$mink | protected | property | Mink session manager. | |||
| HttpKernelUiHelperTrait::assertSession | public | function | Returns WebAssert object. | |||
| HttpKernelUiHelperTrait::buildUrl | protected | function | Builds a URL from a system path or a URL object. | |||
| HttpKernelUiHelperTrait::clickLink | protected | function | Follows a link by complete name. | |||
| HttpKernelUiHelperTrait::drupalGet | protected | function | Retrieves a Drupal path. | |||
| HttpKernelUiHelperTrait::getDefaultDriverInstance | protected | function | Gets an instance of the default Mink driver. | |||
| HttpKernelUiHelperTrait::getNodeElementsByXpath | protected | function | Performs an xpath search on the contents of the internal browser. | |||
| HttpKernelUiHelperTrait::getSession | public | function | Returns Mink session. | |||
| HttpKernelUiHelperTrait::getUrl | protected | function | Gets the current URL from the browser. | |||
| HttpKernelUiHelperTrait::initMink | protected | function | Initializes Mink sessions. | |||
| KernelTestBase::$classLoader | protected | property | The class loader. | |||
| KernelTestBase::$configImporter | protected | property | The configuration importer. | |||
| KernelTestBase::$configSchemaCheckerExclusions | protected static | property | An array of config object names that are excluded from schema checking. | 4 | ||
| KernelTestBase::$container | protected | property | The test container. | |||
| KernelTestBase::$databasePrefix | protected | property | The test database prefix. | |||
| KernelTestBase::$keyValue | protected | property | The key_value service that must persist between container rebuilds. | |||
| KernelTestBase::$siteDirectory | protected | property | The relative path to the test site directory. | |||
| KernelTestBase::$strictConfigSchema | protected | property | Set to TRUE to strict check all configuration saved. | 9 | ||
| KernelTestBase::$usesSuperUserAccessPolicy | protected | property | Set to TRUE to make user 1 a super user. | 1 | ||
| KernelTestBase::$vfsRoot | protected | property | The virtual filesystem root directory. | |||
| KernelTestBase::assertPostConditions | protected | function | 1 | |||
| KernelTestBase::bootEnvironment | protected | function | Bootstraps a basic test environment. | |||
| KernelTestBase::bootKernel | protected | function | Bootstraps a kernel for a test. | 1 | ||
| KernelTestBase::config | protected | function | Configuration accessor for tests. Returns non-overridden configuration. | |||
| KernelTestBase::disableModules | protected | function | Disables modules for this test. | |||
| KernelTestBase::enableModules | protected | function | Enables modules for this test. | 2 | ||
| KernelTestBase::getConfigSchemaExclusions | protected | function | Gets the config schema exclusions for this test. | |||
| KernelTestBase::getDatabaseConnectionInfo | protected | function | Returns the Database connection info to be used for this test. | 3 | ||
| KernelTestBase::getDatabasePrefix | public | function | Gets the database prefix used for test isolation. | |||
| KernelTestBase::getExtensionsForModules | private | function | Returns Extension objects for $modules to install. | |||
| KernelTestBase::getModulesToEnable | protected static | function | Returns the modules to install for this test. | |||
| KernelTestBase::initFileCache | protected | function | Initializes the FileCache component. | |||
| KernelTestBase::installConfig | protected | function | Installs default configuration for a given list of modules. | |||
| KernelTestBase::installEntitySchema | protected | function | Installs the storage schema for a specific entity type. | |||
| KernelTestBase::installSchema | protected | function | Installs database tables from a module schema definition. | |||
| KernelTestBase::register | public | function | Registers test-specific services. | Overrides ServiceProviderInterface::register | 42 | |
| KernelTestBase::render | protected | function | Renders a render array. | 1 | ||
| KernelTestBase::setInstallProfile | protected | function | Sets the install profile and rebuilds the container to update it. | |||
| KernelTestBase::setSetting | protected | function | Sets an in-memory Settings variable. | |||
| KernelTestBase::setUpFilesystem | protected | function | Sets up the filesystem, so things like the file directory. | 3 | ||
| KernelTestBase::tearDown | protected | function | 10 | |||
| KernelTestBase::tearDownCloseDatabaseConnection | public | function | Additional tear down method to close the connection at the end. | |||
| KernelTestBase::vfsDump | protected | function | Dumps the current state of the virtual filesystem to STDOUT. | |||
| KernelTestBase::__sleep | public | function | Prevents serializing any properties. | |||
| RandomGeneratorTrait::getRandomGenerator | protected | function | Gets the random generator for the utility methods. | |||
| RandomGeneratorTrait::randomMachineName | protected | function | Generates a unique random string containing letters and numbers. | |||
| RandomGeneratorTrait::randomObject | public | function | Generates a random PHP object. | |||
| RandomGeneratorTrait::randomString | public | function | Generates a pseudo-random string of ASCII characters of codes 32 to 126. | |||
| StorageCopyTrait::replaceStorageContents | protected static | function | Copy the configuration from one storage to another and remove stale items. | |||
| UserCreationTrait::checkPermissions | protected | function | Checks whether a given list of permission names is valid. | |||
| UserCreationTrait::createAdminRole | protected | function | Creates an administrative role. | |||
| UserCreationTrait::createRole | protected | function | Creates a role with specified permissions. | |||
| UserCreationTrait::createUser | protected | function | Create a user with a given set of permissions. | 1 | ||
| UserCreationTrait::grantPermissions | protected | function | Grant permissions to a user role. | |||
| UserCreationTrait::setCurrentUser | protected | function | Switch the current logged in user. | |||
| UserCreationTrait::setUpCurrentUser | protected | function | Creates a random user account and sets it as current user. |
Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.